#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Feb 11 10:02:19 2022

@author: monroy
"""

import pandas as pd
import numpy as np
from numpy.linalg import eig
from scipy import stats
from statistics import NormalDist
import sklearn as sk
from sklearn import preprocessing

import sys


def shapiro(x):
    shapiro_test = stats.shapiro(x)
    return(shapiro_test.statistic)

class goft:


    def mvshapiro_test(X):
    
        if(isinstance(X, list) == True):
            X = np.matrix(X)
            X = np.transpose(X)
        
        n = np.shape(X)[0]
        p = np.shape(X)[1]
    
        if(n < 12 | n > 5000):
            sys.exit(print('Sample size must be between 12 and 5000'))
        
        if(n <= p):
            sys.exit(print('Sample size must be larger than vector dimension'))
        
        if(n > p):
            x = sk.preprocessing.scale(X, axis=0, with_mean = True, with_std = False, copy = True)
            cov_matrix = np.cov(np.transpose(X)) 
            eigenv, e_vec = eig(cov_matrix)
            e_vec = np.matrix(e_vec)
        
            mat = np.diag(1/np.sqrt(eigenv))
        
            sqrS = np.dot(e_vec, mat) 
            sqrS = np.dot(sqrS, np.transpose(e_vec))
        
            z = np.dot(sqrS, np.transpose(x))
            z = np.transpose(z)
            z = pd.DataFrame(z)
        
            w = z.apply(shapiro)
            wast = np.mean(w)
        
            y = np.log(n)
            w1 = np.log(1 - wast)
        
            m = -1.5861 - 0.31082 * y - 0.083751 * y**2 + 0.0038915 * y**3
            s = np.exp(-0.4803 - 0.082676 * y + 0.0030302 * y**2)
            s2 = s**2
        
            sigma2 = np.log((p - 1 + np.exp(s2))/p)
        
            mu1 = m + s2/2 - sigma2/2
        
            p_value = 1 - NormalDist(mu = mu1, sigma = np.sqrt(sigma2)).cdf(w1)
        
        
            results1 = {'Statistic' : round(wast,4), 'p value' : round(p_value,4), 
                    'Method' : 'Generalized Shapiro-Wilk test for Multivariate Normality'}
        
            return results1

        def gamma_test(x):  

            if( min(x) < 0):
              sys.exit(print('The dataset contains negative observations. All data must be non-negative real numbers.'))
  
            x = np.array(x)  
            x = x[x > 0] 

            samplerange = max(x) - min(x)
 
            if(samplerange == 0):
              sys.exit(print('All observations are identical.'))
  
            n = len(x)   # adjusted sample size without NA values
            z = np.log(x)
            x_bar = np.mean(x)
            s2_x = sum((x - np.mean(x))**2)/(len(x) -1)
            b_check = np.cov(x, z)[0,1]
            a_check = x_bar / b_check
            v       = np.sqrt(n * a_check) * (s2_x / (x_bar * b_check) - 1)
            p_value = 2 * (1- NormalDist(mu = 0, sigma = np.sqrt(2)).cdf(abs(v)))
  
  
            results1 = {'Statistic' : v, 'p value' : round(p_value,4),
                    'Method' : 'Test of fit for the Gamma distribution'}

            return results1
        
        
        
    
